/* Functions in sdpmain.c */
int main(int argc,char *argv[]);

/* In params.c */
void SetParams(sdpdat *);
void PrintParams(sdpdat *sdt);

/* in sdpinput.c */
int DataIn(sdpdat *);
int CheckArgs(int,char**,char*);
int LeftDots(char*,int);

/* sdpproc.c */
int NumChol(sdpdat* ,double* ,int);

/* sdpsymb.c */
int MchlSetup(sdpdat* );

/* Functions in dualalg.c */
int DualSDP(sdpdat *);
void DoubleCopy(double *, double *, int );
double Dot(double *, double *, int);
void AddVecs(double, double *, double, double *, double *, int);
double EvalPotential(sdpdat *,double);

/* Functions in algM.c */
double VDotSD(spvec *, double* ); 
/* static double VDotSS(spvec *, spvec *, double* ); */
void MakeDense( spvec *, double * , int); 
void AlgorithmM(sdpdat *);

/* Functions in smwchol.c */
void CholSolver (double **, double *, double *, int );
int CholFactor ( double **, int , double *);
void LUSolver(double **, double *, int);
void LUFactor(double **, int);
void MakeSMWmat(sdpdat*, double *);
void SMWupdate(smwTools *, spvec*, double*, double*, int, int);


/* Function located in checkpsd.c */
/* static double VDotDD(double *, double *, double *, int); */
int CheckPSD(sdpdat *, double *, chfac *);
double LPVariables(sdpdat *, double *, double *);
int RVectorCoeffs(sdpdat *, double *);


/* Functions in sdpprint.c */

void PrintHeader(void);
int FprintHeader(void);
void PrintEnd(sdpdat *,clock_t tim[]);
void PrintTitle(sdpdat *, double, double );
void PrintIt(sdpdat *, int);
void PrintIntObj(int, double, double, double, params *);
void PrintVecSol(double *, int , char *, probtype);
void PrintEndSDP(sdpdat *);
void SaveSolution(double, double *, int, char *, int);


/* Functions in initvars.c */
int InitialPoint(sdpdat *);
/* static void Initial_y(sdpdat *); */
/* static void MakeLaplacian() */
/* static void NegativeObjective() */
void Initial_X(sdpdat *, int *);

/* Functions in createS.c */
void CreateS1(sdpdat*, int *, int *);
void CreateS2(int *, int *, int *, int);
void CreateS(sdpdat *,double *);

/* Functions in rank1.c */
double EvalObjective( symat *, double *, int); 
void GetRandVec(double *, int); 
void RankReduce( sdpdat * ); 
void ATdyTv(sdpdat *, double *, double *, double*);


/* Functions in heurist.c */
double GetDualRho( sdpdat *);
void IncreaseRho(sdpdat *);
void DecreaseRho(sdpdat *);
void GetStepSize( sdpdat *, int, int, int);
int FindDenseMatrix(sdpdat *);
void SetRhoScale(sdpdat *, double *, double);

/* Dense factorization routines in sdpdmat.c */
int dMatFact(double **, double *, double *, int);
int dMatSolve(double **, double *, double *, int);

/*
char tolower(char); */ /* Only LINIX seems to need this line */


