
#include "SDPdef.h"


int MatReadData(sdpmatlabdata *dp, sdpdat *sdt){

  int i,j,nn0,cnnz,rownnz;

  sdt->n=dp->n;
  sdt->m=dp->m;
  sdt->p=dp->p;
  

  sdt->rtyp=(char*)malloc(sdt->m*sizeof(char));
  if (!sdt->rtyp)  {printf(" Out of space.\n"); return 1; }
  for (i=0; i<dp->m; i++) sdt->rtyp[i]='E';
  
  sdt->b=dAlloc(dp->m,"Out of Space");
  for (i=0; i<dp->m; i++)  sdt->b[i]=dp->b[i];
  
  if (sdt->p>0){ 
    sdt->cvec =dAlloc(dp->p,"Out of Space");
    for (i=0; i<dp->p; i++) sdt->cvec[i]=dp->cvec[i];
  } else sdt->cvec=NULL;

  

  /* Compute number of nonzeros in C */
  nn0=0;
  for (i=0; i<dp->cnnzmax; i++){
    if (dp->cjc[dp->cir[i]]>i && i<dp->cjc[dp->n] && dp->cval[i] !=0 ){
      nn0++;
    }
  }
  sdt->pnnz=nn0;
  sdt->cmat =SymAlloc(dp->n,nn0,NULL);
  for (i=0; i<dp->n; i++)     sdt->cmat->diag[0]=0;
  
  cnnz=0;
  for (j=0; j<dp->cjc[sdt->n]; j++){
    if ( dp->cjc[dp->cir[j]]>j && dp->cval[j] !=0 && 
	 j<dp->cjc[dp->n] && cnnz<nn0 ){
      sdt->cmat->roff->ja[cnnz]=dp->cir[j] ;
      sdt->cmat->roff->an[cnnz]=dp->cval[j] ;
      cnnz++;
    }
  }


  j=0; cnnz=0;
  for (i=0; i<dp->n; i++){
    sdt->cmat->roff[i].ja = &(sdt->cmat->roff->ja[cnnz]);
    sdt->cmat->roff[i].an = &(sdt->cmat->roff->an[cnnz]);
    rownnz=0;
    while (j<dp->cjc[i+1] && j<dp->cjc[dp->n]){
      if ( dp->cjc[dp->cir[j]]>j && dp->cval[j] !=0 && 
	 j<dp->cjc[dp->n] && cnnz<nn0 ){
	rownnz++;  cnnz++;
      }
      if ( dp->cir[j] == i ) sdt->cmat->diag[i]=dp->cval[j];
      j++;
    }
    sdt->cmat->roff[i].nn0 = rownnz;
  }


  /* LP constraint vectors */
 if (dp->p>0){ 
    sdt->avnz=dp->ahatjc[dp->m];
    dp->ahatnnz=dp->ahatjc[dp->m];
    sdt->avecs=mAlloc(dp->m,dp->ahatjc[dp->m],NULL);
    sdt->avecs->maxnrow=dp->m;
    sdt->avecs->nrow=dp->m;
    sdt->avecs->non0=dp->ahatnnz;
    
    for (i=0; i<dp->ahatnnz; i++){
      sdt->avecs->rows->ja[i]=dp->ahatir[i];
      sdt->avecs->rows->an[i]=dp->ahatval[i];
    }
    for (i=0; i<dp->m; i++){
      sdt->avecs->rows[i].ja = &(sdt->avecs->rows->ja[dp->ahatjc[i]]);
      sdt->avecs->rows[i].an = &(sdt->avecs->rows->an[dp->ahatjc[i]]);
      sdt->avecs->rows[i].nn0= dp->ahatjc[i+1]-dp->ahatjc[i];
    }
 } else{

   sdt->avnz=0;
   dp->ahatnnz=0;
   sdt->avecs=mAlloc(dp->m,1,NULL);

   for (i=0; i<dp->m; i++){
     sdt->avecs->rows[i].an= NULL;
     sdt->avecs->rows[i].ja= NULL;
     sdt->avecs->rows[i].nn0= 0;
   }
 }


 /* Constraint one matrices */
 
  dp->annz = dp->ajc[dp->m];
  sdt->amnz=dp->annz; 
  sdt->amats=mAlloc(dp->m,dp->annz+1,NULL);

  for (i=0; i<dp->annz; i++){
    sdt->amats->rows->ja[i]=dp->air[i];
    sdt->amats->rows->an[i]=dp->aval[i];
  }
  
  for (i=0; i<dp->m; i++){
    sdt->amats->rows[i].ja = &(sdt->amats->rows->ja[dp->ajc[i]]);
    sdt->amats->rows[i].an = &(sdt->amats->rows->an[dp->ajc[i]]);
    sdt->amats->rows[i].nn0= dp->ajc[i+1]-dp->ajc[i];
  }

  sdt->useSMW= iAlloc(dp->m, "Setup");

  return 0;
}


int  MatInsertAnswer(sdpmatlabdata *dp, sdpdat *sdt){

  if (dp->outputargs == 1){
    DoubleCopy(sdt->y,dp->y_out,sdt->m);
  } else if (dp->outputargs == 2){
    DoubleCopy(sdt->y,dp->y_out,sdt->m);
    DoubleCopy(sdt->bestv,dp->x,sdt->n);
  } else if (dp->outputargs == 3){
    DoubleCopy(sdt->xmakery,dp->y_out, sdt->m);
    DoubleCopy(sdt->xmakerdy,dp->dy, sdt->m);
    *dp->xmakerc = sdt->xmakerc;
  } else if (dp->outputargs == 4){
    DoubleCopy(sdt->xmakery,dp->y_out, sdt->m);
    DoubleCopy(sdt->xmakerdy,dp->dy, sdt->m);
    *dp->xmakerc = sdt->xmakerc;
    DoubleCopy(sdt->bestv,dp->x,sdt->n);
  }

  return 0;
}
