
/* 
This routine can be modified by the user to define a
vector, vsol.   This vector will define a rank one matrix
that will be used to evaluate the  primal objective function.

Let X be the solution to the primal positive semidefinite
program.  The program provides the vector, vhat, defined by
vhat = V*u,  where X=V*V^T, u is a unit vector, and * means 
multiplication.  

The provided example implements the technique of Goemans and
Williamson for finding solutions to the maximum cut problem.

The integer, n, is the length of the two vectors.  Although
the routine may be modified, but its name must remain the same.
*/

void UserRule(double *vhat, double *vsol, int n){

  int i;

  for (i=0;i<n;i++){
    if (vhat[i]<0.0) vsol[i] =  1;
    else             vsol[i] = -1;
  }
}
